import $ from 'jquery';
import scrollTo from './scrollTo';
import info from './info';

const NAMESPACE = 'scrollTo';
const OtherScrollTo = $.fn.scrollTo;

const jQueryScrollTo = function(options, ...args) {
  if (typeof options === 'string') {
    const method = options;

    if (/^_/.test(method)) {
      return false;
    } else if ((/^(get)/.test(method))) {
      const instance = this.first().data(NAMESPACE);
      if (instance && typeof instance[method] === 'function') {
        return instance[method](...args);
      }
    } else {
      return this.each(function() {
        const instance = $.data(this, NAMESPACE);
        if (instance && typeof instance[method] === 'function') {
          instance[method](...args);
        }
      });
    }
  }

  return this.each(function() {
    if (!$(this).data(NAMESPACE)) {
      $(this).data(NAMESPACE, new scrollTo(this, options));
    }
  });
};

$.fn.scrollTo = jQueryScrollTo;

$.scrollTo = $.extend({
  setDefaults: scrollTo.setDefaults,
  noConflict: function() {
    $.fn.scrollTo = OtherScrollTo;
    return jQueryScrollTo;
  }
}, info);
